 /*
  * Khoros: $Id$
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id$";
#endif

 /*
  * $Log$
  */

/*
 * Copyright (C) 1993, 1994, 1995, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "glinecolor.h"
/*-----------------------------------------------------------
| 
|  Routine Name: glinecolor_get_args
| 
|       Purpose: Gets command line args for glinecolor
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname glinecolor
|          Date: Apr 13, 1995
| Modifications: 
| 
------------------------------------------------------------*/
void glinecolor_get_args(
    kform *pane)
{

	static char *sync_error_mesg = "Generated code for glinecolor is out of sync with arguments specified in glinecolor's *.pane file; please rerun ghostwriter on glinecolor.";


	/*
	 * allocate the glinecolor structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((unsigned)1, (unsigned) sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "glinecolor_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "cmap",
			  &(clui_info->cmap_file),
			  &(clui_info->cmap_flag))))
	{
	    kerror(NULL, "glinecolor_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "name",
			  &(clui_info->name_string),
			  &(clui_info->name_flag))))
	{
	    kerror(NULL, "glinecolor_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "close",
			  &(clui_info->close_logic),
			  &(clui_info->close_flag))))
	{
	    kerror(NULL, "glinecolor_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "glinecolor_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



