 /*
  * Khoros: $Id$
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id$";
#endif

 /*
  * $Log$
  */

/*
 * Copyright (C) 1993, 1994, 1995, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "meigen.h"
/*-----------------------------------------------------------
| 
|  Routine Name: meigen_get_args
| 
|       Purpose: Gets command line args for meigen
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname meigen
|          Date: Apr 08, 1995
| Modifications: 
| 
------------------------------------------------------------*/
void meigen_get_args(
    kform *pane)
{

	static char *sync_error_mesg = "Generated code for meigen is out of sync with arguments specified in meigen's *.pane file; please rerun ghostwriter on meigen.";


	/*
	 * allocate the meigen structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((unsigned)1, (unsigned) sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "meigen_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o1",
			  &(clui_info->o1_file),
			  &(clui_info->o1_flag))))
	{
	    kerror(NULL, "meigen_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o2",
			  &(clui_info->o2_file),
			  &(clui_info->o2_flag))))
	{
	    kerror(NULL, "meigen_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



